///////////////////////////////////////////////////////////////////////
//
// David Cheung
// U49303740
// CS 540: AI
// HW 2
// Feb 24, 1999
//////////////////////////////////////////////////////////////////////
// node.cpp: implementation of the node class.
//
//////////////////////////////////////////////////////////////////////

#include "node.h"
#include <stdio.h>


void arraycp(int arraysource[], int arraydest[])
{
	int tmp_int=0;
	for(tmp_int=0;tmp_int<9;tmp_int++)
	{
		arraydest[tmp_int]=arraysource[tmp_int];
	}
}


//////////////////////////////////////////////////////////////////////
// node Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
static int ident=0;

node::node(int a, int b, int c,
		   int d, int e, int f,
		   int g, int h, int i)
{

	id=++ident;
	parent=NULL;
	sister=NULL;
	child=NULL;
	next=NULL;
	prev=NULL;
	stuffdata(a,b,c,d,e,f,g,h,i);
	depth=0;
	pathcost=0;

}

node::node(node *basenode)
{
	// This added function will allow to create/duplicate
	// a new node.
	arraycp(basenode->data,data);
	id=++ident;
	parent=NULL;
	sister=NULL;
	child=NULL;
	next=NULL;
	prev=NULL;
	depth=0;
	pathcost=0;

}

node::~node()
{
	if(next) next->prev=prev;
	if(prev) prev->next=next;

}

void node::printfile(FILE *ofp)
{

	fprintf(ofp,"%d %d %d %d %d %d %d %d %d \n",
		data[0], data[1], data[2],
		data[3], data[4], data[5],
		data[6], data[7], data[8]);

}

void node::printdata()
{
	int i=0;
	printf("%d %d %d %d %d %d %d %d %d \n",
			data[0], data[1], data[2],
			data[3], data[4], data[5],
			data[6], data[7], data[8]);

}


void node::stuffdata(int a, int b, int c, int d , int e, int f, 
					 int g , int h, int i)
{	

	data[0]=a;
	data[1]=b;
	data[2]=c;
	data[3]=d;
	data[4]=e;
	data[5]=f;
	data[6]=g;
	data[7]=h;
	data[8]=i;

}

void node::stuffdata(int source[])
{
	arraycp(source, data);
}
